#ifndef _INCLUDE_aimms_OrdinalDenseLevel
#define _INCLUDE_aimms_OrdinalDenseLevel

#include "ElementLevel.h"

namespace aimms{

    // A level that iterates all elements of the domain set, assuming the datablock stores all ordinals 
    class OrdinalDenseLevel : public ElementLevel 
    {
        friend class Iterator;

    private:
        OrdinalDenseLevel(Level* parent, int card, IElement* elem);
        virtual void HandleSliceNoTuple(int slicenr); 
        virtual void HandleSlice(int slicenr); 
        virtual void Apply(const double& value, int slicenr); 
    };
}
#endif