#ifndef _INCLUDE_aimms_Level
#define _INCLUDE_aimms_Level

namespace aimms{

    class Level 
    {
    public:
        virtual void HandleSliceNoTuple(int slicenr) = 0; // iterates slices; sets position
        virtual void HandleSlice(int slicenr) = 0; // iterates slices; sets position, adapts m_Tuple
        virtual void Apply(const double& value, int slicenr) = 0; // writes the current tuple position, assuming it is part of the active slice
    };
}
#endif